/* cmd_neonfun_uno.c - NeonServ v5.6
 * Copyright (C) 2011-2012  Philipp Kreil (pk910)
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License 
 * along with this program. If not, see <http://www.gnu.org/licenses/>. 
 */

#include "cmd_neonfun.h"
#include "game_uno.h"

CMD_BIND(neonfun_cmd_uno) {
    struct ChanUser *chanuser = getChanUser(user, chan);
    if(!chanuser) return;
    struct uno_game *game;
    for(game = uno_active_games; game; game = game->next) {
        if(chan == game->channel) {
            if(game->state == UNO_STATE_WAITING)
                break;
            else {
                reply(textclient, user, "NF_UNO_ALREADY_RUNNING", chan->name);
                return;
            }
        }
    }
    if(game) {
        //check if player has already joined
        struct uno_player *player, *last_player = NULL;
        for(player = game->player; player; player = player->next) {
            if(player->chanuser == chanuser) {
                reply(textclient, user, "NF_UNO_ALREADY_JOINED");
                return;
            } else
                last_player = player;
        }
        if(!last_player) return; //error (game without players?)
        player = malloc(sizeof(*player));
        player->chanuser = chanuser;
        player->count = 0;
        player->cards = NULL;
        player->timeout = 0;
        player->prev = last_player;
        player->next = NULL;
        last_player->next = player;
        game->players++;
        uno_reply(game, user, "NF_UNO_USER_JOINED", user->nick);
    } else {
        game = malloc(sizeof(*game));
        game->channel = chan;
        game->textbot = textclient;
        game->state = UNO_STATE_WAITING;
        game->reverse_direction = 0;
        game->take_cards_pending = 0;
        game->deck = NULL;
        game->top_card = NULL;
        struct uno_player *player = malloc(sizeof(*player));
        player->chanuser = chanuser;
        player->count = 0;
        player->cards = NULL;
        player->timeout = 0;
        player->prev = NULL;
        player->next = NULL;
        game->player = player;
        game->winner = NULL;
        game->active_player = NULL;
        game->players = 1;
        game->timer = timeq_add(30, module_id, uno_game_wait_timeout, game);
        game->next = uno_active_games;
        uno_active_games = game;
        uno_reply(game, user, "NF_UNO_CREATED", user->nick);
    }
}
