/* cmd_neonserv_mdeluser.c - NeonServ v5.6
 * Copyright (C) 2011-2012  Philipp Kreil (pk910)
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License 
 * along with this program. If not, see <http://www.gnu.org/licenses/>. 
 */

#include "cmd_neonserv.h"

/*
* argv[0]  access (format: minaccess-maxaccess)
* argv[1]  pattern
*/

CMD_BIND(neonserv_cmd_mdeluser) {
    int min_access, max_access;
    char *seperator = strstr(argv[0], "-");
    if(seperator) {
        *seperator = '\0';
        seperator++;
        min_access = atoi(argv[0]);
        max_access = atoi(seperator);
        if(max_access < min_access) {
            reply(textclient, user, "NS_INVALID_ACCESS_RANGE", min_access, max_access);
            return;
        }
    } else {
        min_access = atoi(argv[0]);
        max_access = min_access;
    }
    if(max_access >= getChannelAccess(user, chan)) {
        if(isGodMode(user)) {
            event->flags |= CMDFLAG_OPLOG;
        } else {
            reply(textclient, user, "NS_NO_ACCESS");
            return;
        }
    }
    MYSQL_RES *res;
    MYSQL_ROW row;
    int del_count = 0;
    printf_mysql_query("SELECT `user_user`, `chanuser_id` FROM `chanusers` LEFT JOIN `users` ON `chanuser_uid` = `user_id` WHERE `chanuser_cid` = '%d' AND `chanuser_access` >= '%d' AND `chanuser_access` <= '%d'", chan->channel_id, min_access, max_access);
    res = mysql_use();
    while((row = mysql_fetch_row(res)) != NULL) {
        if(!match(argv[1], row[0])) {
            del_count++;
            printf_mysql_query("DELETE FROM `chanusers` WHERE `chanuser_id` = '%s'", row[1]);
        }
    }
    reply(textclient, user, "NS_MDELUSER_DONE", del_count, argv[1], min_access, max_access, chan->name);
    if(del_count)
        logEvent(event);
}

